-- MoonTimeDesignObj.lua

function MoonTimeDesignObj()
	-- dieses Frame besitzt die Funktionen:
	-- GetStarrainCD
	-- GetTreantsCD
	-- GetStarsurgeCD
	-- GetMoonfireCD
	-- GetInsectSwarmCD
	-- GetEclipseEndTimes
	-- Next()
	local frame = CreateFrame( "Frame" )
	
	W_Flying = 0;
	SF_Flying = 0;
	SS_Flying = 0;
	
	
	frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
	
	
	frame:SetScript("OnEvent", 
		function( self, event, ...)
		local EDir = frame:GetEclipseDirection();
			if (event=="UNIT_SPELLCAST_SUCCEEDED") then
				local sourceUnit, spellName = select(1,...);
													
				if (sourceUnit == "player") then
					if (spellName == W_name and EDir =="moon") then
						W_Flying = W_Flying +1;
					elseif (spellName == SF_name and EDir =="sun") then
						SF_Flying = SF_Flying +1;
					elseif (spellName == SS_name) then
						SS_Flying = SS_Flying +1;
					end
				end

			end  
  
	if (event=="COMBAT_LOG_EVENT_UNFILTERED") then
		local timestamp, type, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags = select(1, ...)
		  
		if (sourceName == UnitName("player")) then

			if (type=="SPELL_ENERGIZE") then
				local amount, powerType = select(12, ...)

				if (powerType==8) then
					if (abs(amount) < 20 and abs(amount) >14 and SS_Flying>0) then
						SS_Flying = SS_Flying -1;
					elseif (amount > 19 and EDir =="sun") then
						SF_Flying = SF_Flying -1;
					elseif (amount < -12 and EDir =="moon") then
						W_Flying = W_Flying -1;
					end
				end
			end
		
			if (type=="SPELL_MISSED") then
				local spellName = select(10,...);
					if (spellName == W_name and EDir =="moon") then
						W_Flying = W_Flying -1;
					elseif (spellName == SF_name and EDir =="sun") then
						SF_Flying = SF_Flying -1;
					elseif (spellName == SS_name and SS_Flying>0) then
						SS_Flying = SS_Flying -1;
					end
			end
		end
			
		--[[
		if (type=="SPELL_DAMAGE" and sourceName == UnitName("player")) then
			local spellId, spellName, spellSchool = select(9, ...)
			--DEFAULT_CHAT_FRAME:AddMessage(spellName .. " gezaubert " .. sourceName);
			ZornFlying = ZornFlying +1;
		end
		--]]
  end
end

	)

	frame.GetStarrainCD = function()
		local start, duration, enabled = GetSpellCooldown(SR_name);
		
		return start+duration-GetTime();
	end
	
	frame.GetTreantsCD = function()
		local start, duration, enabled = GetSpellCooldown(Treants_name);
		
		return start+duration-GetTime();
	end

	frame.GetStarsurgeCD = function()
		local start, duration, enabled = GetSpellCooldown(SS_name);
		return duration;
	end

	frame.GetMoonfireCD = function()
		local _, _, _, _, _, _, MF_expirationTime, MF_unitCaster = UnitDebuff("target", MF_name);
		
		if MF_unitCaster=="player" then
			return MF_expirationTime-GetTime();
		else
			return -1;
		end
	end

	frame.GetSunfireCD = function()
		local _, _, _, _, _, _, SunF_expirationTime, SunF_unitCaster = UnitDebuff("target", SunF_name);
		
		if SunF_unitCaster=="player" then
			return SunF_expirationTime-GetTime();
		else
			return -1;
		end
	end

	frame.GetInsectSwarmCD = function()
		local _, _, _, _, _, _, IS_expirationTime, IS_unitCaster = UnitDebuff("target", IS_name);
		
		if IS_unitCaster=="player" then
			return IS_expirationTime-GetTime();
		else
			return -1;
		end
	end
	
	local lunar = 0;
	local solar = 0;
	
	frame.GetEclipseEndTimes = function()
	
		_, _, _, _, _, _, lunar_expirationTime, _, _, _, _ = UnitBuff("player", Lunar_name);
		_, _, _, _, _, _, solar_expirationTime, _, _, _, _ = UnitBuff("player", Solar_name);
	
		if lunar_expirationTime then
			lunar = lunar_expirationTime;
		end
		if solar_expirationTime then
			solar = solar_expirationTime;
		end

		return lunar, solar	
	end
	

	
		local ttd = {
	
	["hp"] = 0,
	["timestamp"] = 0,
	["ttd"] = 0,
};
	
	frame.TimeTillDeath = function ()
	
		tmp = GetTime()
		
		if tmp - 1 > ttd["timestamp"] then
			local hpdiff = ttd["hp"]-UnitHealth("target")
			local timediff = tmp-ttd["timestamp"]
			local timetilldeath = UnitHealth("target")/hpdiff*timediff
			
			if timetilldeath then
				ttd["ttd"] = timetilldeath
			end
		
		
			ttd["hp"] = UnitHealth("target")
			ttd["timestamp"] = tmp
		
		end
		
		return ttd["ttd"] 
		
		
		
	end
	
	frame.GetEclipseDirection = function()
		local dir = GetEclipseDirection()
		if ( not dir ) then
			dir = "sun";
		end
		local power = UnitPower("player", 8)
		
		return dir, power
	end

	frame.isT11proc = function()
	local name, _, _, _, _, _, expirationTime, _, _, _, _ = UnitBuff("player", T11_name);
		if ( name ) then
			return expirationTime-GetTime();
		else
			return -1;
		end
	end		
	
	frame.isSolar = function()
		local name, _, _, _, _, _, solar_expirationTime, _, _, _, _ = UnitBuff("player", Solar_name);
		if ( name ) then
			SF_Flying = 0;         -- Sicherungsreset
			return true
		else
			return false
		end
	end

	frame.isLunar = function()
		local name, _, _, _, _, _, solar_expirationTime, _, _, _, _ = UnitBuff("player", Lunar_name);
		if ( name ) then
			W_Flying = 0;     -- Sicherungsreset
			return true
		else
			return false
		end
	end	

	frame.isSolarSoon = function()
		local EDir, EPower = frame:GetEclipseDirection();
		
		if ( (EDir == "sun" and EPower > 79) or (EPower == 100 and not frame:isSolar()) ) then
			return true
		end
		return false
	end
	
	frame.isSolarOverSoon = function()
		local EDir, EPower = frame:GetEclipseDirection();
		
		if ( EDir == "moon" and EPower < 15 and EPower > -1 ) then
			return true
		end
		return false
	end
	
	frame.isLunarSoon = function()
		local EDir, EPower = frame:GetEclipseDirection();
		
		if ( ( EDir == "moon" and EPower < -73 ) or (EPower == -100 and not frame:isLunar()) ) then
			return true
		end
		return false
	end

	frame.isLunarOverSoon = function()
		local EDir, EPower = frame:GetEclipseDirection();
		
		if ( EDir == "sun" and EPower > -21 and EPower < 1 ) then
			return true
		end
		return false
	end	
	
	


local t11_rota = "function mynext(frame) "
		.."local spell, _, _, _, startTime, endTime, _, castID, _ = UnitCastingInfo(\"player\"); "
		.."local EDir, EPower = frame:GetEclipseDirection(); "
		.."if ( not spell ) then "
			.."startTime = 0; "
			.."endTime = 1.6; "
		.."end  "
			.." "
		.."local casttime = 0; "
			.." "
		.."if (spell) then  "
			.."casttime = endTime/1000-GetTime();  "
		.."end  "
		.."--[[ Schaut, ob der nchste Zauber schon der andere Spam sein sollte, Bypass ber EDir --]]  "
		.."if ( EDir == \"moon\" and EPower < -86+13*W_Flying+15*SS_Flying and (spell or W_Flying+SS_Flying>0)) then "
			.."EDir = \"sun\"  "
		.."end  "
		.."if ( EDir == \"sun\" and EPower > 79-20*SF_Flying-15*SS_Flying and (spell or SF_Flying+SS_Flying>0)) then "
			.."EDir = \"moon\"  "
		.."end "
		.."--[[ EDir Bypass vorbei--]]  "
			.." "
		.."--[[ 4t11 rota --]]  "
		.."if ( (frame:isSolar() or frame:isLunar()) and frame:GetInsectSwarmCD()<0 and (frame:isT11proc()<casttime or (EPower<50 and EPower >0))) then "
			.."return IS_icon "
		.."end "
		.."if ( frame:isSolar() and frame:GetSunfireCD() <0 and frame:isT11proc()<casttime ) then "
			.."return SunF_icon  "
		.."end "
		.."if ( frame:isLunar() and frame:GetMoonfireCD() <0 and frame.isT11proc()<casttime ) then  "
			.."return MF_icon  "
		.."end "
		.."if ( frame:GetStarsurgeCD() < 1.6 and spell ~= SS_name and not frame:isSolarSoon() and not frame:isLunarSoon() and frame:GetStarsurgeCD() < endTime-startTime) then  "
			.."return SS_icon "
		.."end  "
		.."--[[ 4t11 rota ende --]] "
		.."if ( EDir == \"sun\" ) then "
			.."return SF_icon "
		.."else "
			.."return W_icon "
		.."end "
	.."end";

local normal_rota = "function mynext(frame) "
	.."local spell, _, _, _, startTime, endTime, _, castID, _ = UnitCastingInfo(\"player\"); "
		.."local EDir, EPower = frame:GetEclipseDirection(); "
		.."if ( not spell ) then "
			.."startTime = 0; "
			.."endTime = 1.6; "
		.."end "
			.." "
		.."local casttime = 0; "
			.." "
		.."if (spell) then "
			.."casttime = endTime/1000-GetTime(); "
		.."end "
			.." "
		.."--[[ Schaut, ob der nchste Zauber schon der andere Spam sein sollte, Bypass ber EDir--]] "
		.."if ( EDir == \"moon\" and EPower < -86+13*W_Flying+15*SS_Flying and (spell or W_Flying+SS_Flying>0)) then "
			.."EDir = \"sun\" "
		.."end "
			.." "
		.."if ( EDir == \"sun\" and EPower > 79-20*SF_Flying-15*SS_Flying and (spell or SF_Flying+SS_Flying>0)) then "
			.."EDir = \"moon\" "
		.."end "
		.."--[[ EDir Bypass vorbei	--]] "
			.." "
		.."if ( frame:GetStarsurgeCD() < 1.6 and spell ~= SS_name and not frame:isSolarSoon() and not frame:isLunarSoon() and frame:GetStarsurgeCD() < endTime-startTime) then  "
			.."return SS_icon "
		.."end  "
			.." "
		.."if ( (frame:GetInsectSwarmCD() < 0 and not frame:isSolarSoon()) or ( frame:isSolarOverSoon() and frame:GetInsectSwarmCD()<5)) then "
			.."return IS_icon "
		.."end "
		.."if ( EDir==\"sun\" and not frame:isLunar() and not frame:isSolarSoon() and frame:GetMoonfireCD()<casttime and EPower>-1) then "
			.."return MF_icon "
		.."end "
		.."if ( frame:isSolar() and frame:GetSunfireCD()<casttime and frame:GetMoonfireCD()<casttime) then "
			.."return SunF_icon "
		.."end "
		.."if ( frame:isSolarOverSoon() and frame:GetSunfireCD()<5) then "
			.."return SunF_icon "
		.."end "
		.."if ( EDir==\"moon\" and not frame:isSolar() and not frame:isLunarSoon() and frame:GetMoonfireCD()<casttime and frame:GetSunfireCD()<casttime and EPower<1) then "
			.."return MF_icon "
		.."end "
		.."if ( frame:isLunar() and frame:GetMoonfireCD()<casttime and frame:GetSunfireCD()<casttime) then "
			.."return MF_icon "
		.."end "
		.."if ( frame:isLunarOverSoon() and frame:GetMoonfireCD()<5) then "
			.."return MF_icon "
		.."end "
	.."end "
		
	local rota = normal_rota;
	if MoonTime_DB["4t11"] then
		rota = t11_rota;
	end

RunScript(rota)
frame.Next = function ()
	return mynext(frame)
end
	
	
--[[	
	frame.Next = function ()
		local spell, _, _, _, startTime, endTime, _, castID, _ = UnitCastingInfo("player");
		if ( not spell ) then
			startTime = 0;
			endTime = 1.6;
		end
		
		local SS = frame:GetStarsurgeCD();
		local EDir, EPower = frame:GetEclipseDirection();
		local casttime = 0;
		
		if (spell) then
			casttime = endTime/1000-GetTime();
		end

	
--DEFAULT_CHAT_FRAME:AddMessage(MoonTime_DB["t11rota"])

		
		
		-- Schaut, ob der nchste Zauber schon der andere Spam sein sollte, Bypass ber EDir
		if ( EDir == "moon" and EPower < -86+13*W_Flying+15*SS_Flying and (spell or W_Flying+SS_Flying>0)) then
			EDir = "sun"
		end
		
		if ( EDir == "sun" and EPower > 79-20*SF_Flying-15*SS_Flying and (spell or SF_Flying+SS_Flying>0)) then
			EDir = "moon"
		end
		-- EDir Bypass vorbei
RunScript("if ( EDir == \"sun\" ) then return SunF_icon end");	





--return W_icon
--DEFAULT_CHAT_FRAME:AddMessage("test")

--return texture

 --DEFAULT_CHAT_FRAME:AddMessage(test)	
--RunScript("return MF_icon");--]]
--[[ 4t11 rota	
	if ( (frame:isSolar() or frame:isLunar()) and frame:GetInsectSwarmCD()<0 and (not frame:isT11proc() or (EPower<50 and EPower >0))) then
	return IS_icon
	end	

	if ( frame:isSolar() and frame:GetSunfireCD()<0 and not frame:isT11proc() ) then
		return SunF_icon
	end		
	
	if ( frame:isLunar() and frame:GetMoonfireCD()<0 and not frame:isT11proc() ) then
		return MF_icon
	end		
	
	if ( SS < 1.6 and spell ~= "Sternensog" and not frame:isSolarSoon() and not frame:isLunarSoon() and SS < endTime-startTime) then
		return SS_icon
	end
-- 4t11 rota ende --]]
	
--[[  Die nicht 4t11 Rota	
	if ( (frame:GetInsectSwarmCD()<0 and not frame:isSolarSoon()) or ( frame:isSolarOverSoon() and frame:GetInsectSwarmCD()<5)) then
		return IS_icon
	end


	-- Nach lunar, Solar kommt noch nicht, MF setzen
	if ( EDir=="sun" and not frame:isLunar() and not frame:isSolarSoon() and frame:GetMoonfireCD()<casttime and EPower>-1) then
		return MF_icon
	end
	
	-- Solar proct, kein SunF oder MF drauf, SunF setzen
	if ( frame:isSolar() and frame:GetSunfireCD()<casttime and frame:GetMoonfireCD()<casttime) then
		return SunF_icon
	end
	
	-- Solar geht zu Ende, SunF luft nicht mehr lange, SunF setzen
	if ( frame:isSolarOverSoon() and frame:GetSunfireCD()<5) then
		return SunF_icon
	end
	
	-- Nach Solar, kein MF oder SunF drauf, Lunar kommt noch nicht, MF setzen
	if ( EDir=="moon" and not frame:isSolar() and not frame:isLunarSoon() and frame:GetMoonfireCD()<casttime and frame:GetSunfireCD()<casttime and EPower<1) then
		return MF_icon
	end	
	
	-- Lunar proct, kein MF oder SunF drauf, MF setzen
	if ( frame:isLunar() and frame:GetMoonfireCD()<casttime and frame:GetSunfireCD()<casttime) then
		return MF_icon
	end	
	
	-- Lunar geht zu Ende, MF luft nicht mehr lange, MF setzen
	if ( frame:isLunarOverSoon() and frame:GetMoonfireCD()<5) then
		return MF_icon
	end	
--]]	
--[[
	if ( EDir == "sun" ) then
		--texture=SF_icon
	else
		--texture=W_icon
	end

	return texture
	end
--]]
	frame.NextTrash = function ()
		--local Lunar, Solar = frame:GetEclipseEndTimes();
		local EDir, EPower = frame:GetEclipseDirection();
		local MF = frame:GetMoonfireCD()+GetTime();
		local SunF = frame:GetSunfireCD()+GetTime();
		local IS = frame:GetInsectSwarmCD()+GetTime();
		local SS = frame:GetStarsurgeCD()+GetTime();
		
	
		local cast_MF=true;
		local cast_SunF=true;
		local cast_IS=true;
		local cast_W=true;
		local cast_SF=true;
		local cast_SS=true;
		
		local spell, rank, displayName, icon, startTime, endTime, isTradeSkill, castID, interrupt = UnitCastingInfo("player")
		
		if not endTime then
			endTime = GetTime()*1000;
		end
		
		if ( EDir == "sun" ) then
			cast_SunF = false
			cast_W = false
			if MF>endTime/1000  or SunF>endTime/1000 or frame:TimeTillDeath() < 15 then
				cast_MF = false;
				cast_SunF = false
			end
		else
			if EPower>0 then cast_MF = false end
			cast_SF = false
			if SunF>endTime/1000 or MF>endTime/1000 or frame:TimeTillDeath() < 15 then
				cast_SunF = false;
				cast_MF = false
			end
		end
		
		if IS>endTime/1000 or frame:TimeTillDeath() < 15 then
			cast_IS = false;
		end	
		
		if SS>endTime/1000 then
			cast_SS = false;
		end	
			
		
		if cast_SS then
			return SS_icon
		elseif cast_MF then
			return MF_icon
		elseif cast_SunF then
			return SunF_icon
		elseif cast_IS then
			return IS_icon
		elseif cast_W then
			return W_icon
		else
			return SF_icon
		end
	end




	return frame
end

